<?php
require'DBOperations.php';

// Working with Angular JS
header("Access-Control-Allow-Origin: *");
header("Access-Control-Allow-Headers: Origin, X-Requested-With, Content-Type, Authorization, Accept");
header("Access-Control-Allow-Methods: 'HEAD, GET, POST, PUT, PATCH, DELETE'");

// Get header information
$apikey = apache_request_headers();

//Read file name after .php extension
$file = $_SERVER["REQUEST_URI"];
$parts = Explode('.php/', $file);
$filename = $parts[count($parts) - 1];
//echo $filename;

$number = Explode('/', $file);
$lastdigit = $number[count($number) - 1];

if (is_numeric($lastdigit)) {
    //echo $lastdigit;
    $request_id = $lastdigit;
}elseif (!is_numeric($lastdigit)) {
    //echo $lastdigit;
    $request_name = $lastdigit;
}
//echo $request_name;

/*
============================================================================
        * POST Request * 
============================================================================
*/

//Make sure that it is a POST request.
if(strcasecmp($_SERVER['REQUEST_METHOD'], 'POST') == 0){
    //throw new Exception('Request method must be POST!');

//Make sure that the content type of the POST request has been set to application/json
/*$contentType = isset($_SERVER["CONTENT_TYPE"]) ? trim($_SERVER["CONTENT_TYPE"]) : '';
if(strcasecmp($contentType, 'application/json') != 0) {
    throw new Exception('Content type must be: application/json');
}*/

//Receive the RAW post data.
$content = trim(file_get_contents("php://input"));

//Attempt to decode the incoming RAW post data from JSON.
$decoded = json_decode($content, true);

//If json_decode failed, the JSON is invalid.
if(!is_array($decoded)){
    throw new Exception('Received content contained invalid JSON!');
}

/*
============================================================================
        * JSON POST OPERATIONS * 
============================================================================
*/


$ErrorMessage = new ErrorMessage;

    switch ($filename) {
       
        case 'test/insert':
            new TestInsert($decoded, $apikey);
            break;

        case 'test/login/select':
            new TestLoginSelect($decoded, $apikey);
            break;

        case 'test/select':
            new TestSelect($decoded, $apikey);
            break;

        case 'test/delete':
            new TestDelete($decoded, $apikey);
            break;

        case 'test/update':
            new TestUpdate($decoded, $apikey);
            break;
            
		case 'test/createuser':
            new TestCreateuser($decoded, $apikey);
            break;
            
        case 'test/createvendor':
            new TestCreatevendor($decoded, $apikey);
            break;
            
        case 'test/userlogin':
            new TestUserlogin($decoded, $apikey);
            break;
            
        case 'test/userrefcode':
            new TestUserrefcode($decoded, $apikey);
            break;
            
        case 'test/vendorlogin':
            new TestVendorlogin($decoded, $apikey);
            break;
            
        case 'test/updatecust':
            new TestUpdatecust($decoded, $apikey);
            break;
            
        case 'test/updateorupoints':
            new TestUpdateorupoints($decoded, $apikey);
            break;
            
        case 'test/updateoruinorder':
            new TestUpdateoruinorder($decoded, $apikey);
            break;
            
        case 'test/updatepass':
            new TestUpdatepass($decoded, $apikey);
            break;
            
        case 'test/updateadminpass':
            new TestUpdateAdminpass($decoded, $apikey);
            break;
            
        case 'test/forgot/custpass':
            new TestForgotcustpass($decoded, $apikey);
            break;
            
        case 'test/createorder':
            new TestCreateorder($decoded, $apikey);
            break;
                
        case 'test/addaddress':
            new TestAddaddress($decoded, $apikey);
            break;
            
        case 'test/updateproduct':
            new TestUpdateproduct($decoded, $apikey);
            break;
            
        case 'test/adddelarea':
            new TestAdddelarea($decoded, $apikey);
            break;
            
        case 'test/updatedelarea':
            new TestUpdatedelarea($decoded, $apikey);
            break;
            
        case 'test/deletedelarea':
            new TestDeletedelarea($decoded, $apikey);
            break;
            
        case 'test/updateorder':
            new TestUpdateorder($decoded, $apikey);
            break;
            
        case 'test/updatemonthlyorder':
            new TestUpdatemonthlyorder($decoded, $apikey);
            break;
            
        case 'test/orderbystatus':
            new TestOrderbystatus($decoded, $apikey);
            break;
            
        case 'test/venordbystatus':
            new TestVendorordstatus($decoded, $apikey);
            break;
        
        default:
            $ErrorMessage -> WrongOperation();
            break;
    }
     

/*
============================================================================
        * Add new POST operation above *
============================================================================
*/
}

/*
============================================================================
        * GET Request * 
============================================================================
*/

elseif (strcasecmp($_SERVER['REQUEST_METHOD'], 'GET') == 0) {
    
    $ErrorMessage = new ErrorMessage;

    switch ($filename) {

        case 'test/get/all':
            new TestGetAll($apikey);
            break;

        case stripos($filename,'test/get/testid') !== false:
            new TestGetTestId($request_id, $apikey);
            break;
        
        case 'test/get/showprod':
            new TestGetShowprod($decoded, $apikey);
            break;
            
        case 'test/get/showarea':
            new TestGetShowarea($decoded, $apikey);
            break;
            
        case 'test/get/showvendor':
            new TestGetShowvendor($decoded, $apikey);
            break;
            
        case stripos($filename, 'test/get/aid') !== false:
            new TestGetAddressId($request_id, $apikey);
            break;
            
        case stripos($filename, 'test/get/points') !== false:
            new TestGetPoints($request_id, $apikey);
            break;
        
        case stripos($filename, 'test/get/ordhistory') !== false:
            new TestGetOrders($request_id, $apikey);
            break;
            
        case stripos($filename, 'test/get/ordstatus') !== false:
            new TestGetOrdersstatus($request_id, $apikey);
            break;
        
        case stripos($filename, 'test/get/monthlyord') !== false:
            new TestGetMonthlyOrders($request_id, $apikey);
            break;
            
        case stripos($filename, 'test/get/vord') !== false:
            new TestGetVendororders($request_id, $apikey);
            break;
            
        case stripos($filename, 'test/get/todayvord') !== false:
            new TestGetTodayvendororders($request_id, $apikey);
            break;
            
        case stripos($filename, 'test/get/delivervord') !== false:
            new TestGetDeliveredvorders($request_id, $apikey);
            break;
            
        case stripos($filename, 'test/get/oldvord') !== false:
            new TestGetOldvorders($request_id, $apikey);
            break;
            
        case stripos($filename, 'test/get/futurevord') !== false:
            new TestGetFuturevorders($request_id, $apikey);
            break;

        case stripos($filename, 'test/get/mobno') !== false:
            new TestGetMobno($request_id, $apikey);
            break;
            
        default:
            $ErrorMessage -> WrongOperation();
            break;
    }
    

/*
============================================================================
        * Add new GET operation above * 
============================================================================
*/
}

?>
